# MagLev loop
# Batch run of the MagLev force calculation using Perl
# https://www.fieldp.com/example_library/magnetic_levitation.html

# Number of calculations
$NPoint = 42;
# Index of data points
$n = 0;
# Minimum distance - 0.5
$XStart = 1.5;
# Distance increment
$Dx = 0.5;
$x = $XStart;
$Instring = " ";
# Search for this string in the data file
$FString = "|Fxz|";
# Search string found condition, initialize as False
$SCheck = 0;

# Open an output file to write the results
open(OUTFILE,'>','MagLev.txt') or die "Could not create MagLev.txt\n";
# Main loop over data points
do {
# Search string found condition, initialize as False
  $SCheck = 0;
  $n = $n + 1;
  $x = $x + $Dx;
  print "Calculation for spacing ";
  printf ("%7.2f",$x);
  print "\n";
# Run Mesh with plate height as the pass parameter
  system('c:\fieldp\tricomp\mesh.exe',MagLev,$x);
# Run Nelson solution
  system('c:\fieldp\tricomp\nelson.exe','MagLev.NIN');
# Run Nelson analysis
  system('c:\fieldp\tricomp\nelson.exe','MagLev.SCR');
# Open the output data file and read lines
  open(INFILE, '<', 'MagLev.DAT') or die "Could not open MagLev.DAT\n";
  while ($Instring = <INFILE>) {
    if (index($Instring,$FString) != -1) {
      $SCheck = 1;
    }
    if ($SCheck > 0) {
# Target data line, move ahead to determine the force
      if ($SCheck == 5) {
        my @spl = split(' ', $Instring);
# Print the displacement and force        
        printf OUTFILE ("%8.2f",$x);
        print OUTFILE "   ",@spl[1],"\n";
      }
      $SCheck = $SCheck + 1;
    }
  }
# Close the input file
  close(INFILE);
} while($n < $NPoint);

# Close the output file
close(OUTFILE);


